package com.biganto.visual.roompark.presentation.screen.deal

import android.os.Bundle
import android.view.View
import androidx.core.os.bundleOf
import butterknife.BindView
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.base.RoomParkApplication
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.conductor.BigantoBaseController
import com.google.android.material.textview.MaterialTextView
import timber.log.Timber
import javax.inject.Inject


/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */

const val SELECTED_ESTATE_ID_KEY = "SELECTED_ESTATE_INDEX"


class DealScreenController  :
    BigantoBaseController<DealScreenViewState
        , DealScreen
        , DealScreenPresenter>
    , DealScreen {

    constructor(args: Bundle):super(args)

    constructor(id: Int) : super(bundleOf(SELECTED_ESTATE_ID_KEY to id))

    override fun injectDependencies() {
        getComponent()
    }

    @Inject
    override lateinit var injectedPresenter: DealScreenPresenter

    @BindView(R.id.explication_tab)
    lateinit var explicationTab: MaterialTextView

    private fun setToolbar(){
        toolBar.showAll()
        toolBar.appBar.setExpanded(false,false)
        toolBar.collapsingToolbarLayout.title = "СДЕЛКА"
        toolBar.appBar.liftOnScrollTargetViewId = R.id.favorites_cards_recycler_view
        toolBar.appBar.setLiftable(true)
        toolBar.appBarScrollable(false)

//        planTypesTabLayout.
    }

    private fun bindRecycler() {
    }

    override fun onViewBound(v: View) {
        setToolbar()
        bindRecycler()
    }

    override fun render(viewState: DealScreenViewState) {
        super.render(viewState)
        Timber.d("Render state $viewState")
        when(viewState){
            is DealScreenViewState.Idle -> render(viewState)
            is DealScreenViewState.LoadDeal -> render(viewState)
            is DealScreenViewState.SomeError -> render(viewState)
        }
    }

    private fun render(viewState: DealScreenViewState.Idle){

    }

    private fun render(viewState: DealScreenViewState.SomeError) =
        showError(viewState.exception)


    private fun render(viewState: DealScreenViewState.LoadDeal) {
    }

        private fun getComponent() = DaggerDealScreenComponent.factory()
        .create(RoomParkApplication.component,activity as RoomParkMainActivity
            ,args.getInt(SELECTED_ESTATE_ID_KEY))
        .inject(this)

    override fun getLayoutId(): Int = R.layout.deal_scren
}
